﻿using Syncfusion.UI.Xaml.Grid;
using Syncfusion.UI.Xaml.Grid.Cells;
using Syncfusion.UI.Xaml.Grid.Helpers;
using Syncfusion.UI.Xaml.ScrollAxis;
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices.WindowsRuntime;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=402352&clcid=0x409

namespace SfDataGridDemo
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        private ViewModel vm;
        public MainPage()
        {
            this.InitializeComponent();
            vm = this.DataContext as ViewModel;
            vm.OrderInfoCollection.CollectionChanged += CollectionChanged;
        }

        RowColumnIndex rowColumnIndex = new RowColumnIndex();
        private void cancel_Click(object sender, RoutedEventArgs e)
        {
            //Check whether the data is newly added 
            if (this.sfdatagrid.View.IsAddingNew)
            {
                // Which end edit the current cell. by passing false, it revert the entered value.
                if (this.sfdatagrid.SelectionController.CurrentCellManager.CurrentCell.IsEditing)
                    this.sfdatagrid.SelectionController.CurrentCellManager.EndEdit(true);
                var addNewRowController = this.sfdatagrid.GetAddNewRowController();
                addNewRowController.CancelAddNew();
            }
        }
        private void commit_Click(object sender, RoutedEventArgs e)
        {
            // Which avoid the process of committing normal rows. It only processed for AddNewRow.
            var rowIndex = this.sfdatagrid.SelectionController.CurrentCellManager.CurrentCell != null ? this.sfdatagrid.SelectionController.CurrentCellManager.CurrentCell.RowIndex : 0;
            if (this.sfdatagrid.IsAddNewIndex(rowIndex))
            {
                // Which end edit the current cell. by passing false, it commit the entered value.
                if (this.sfdatagrid.SelectionController.CurrentCellManager.CurrentCell.IsEditing)
                    this.sfdatagrid.SelectionController.CurrentCellManager.EndEdit(true);
                //Initialize row and column index after committing new row 
                rowColumnIndex = this.sfdatagrid.SelectionController.CurrentCellManager.CurrentRowColumnIndex;
                var addNewRowController = this.sfdatagrid.GetAddNewRowController();
                addNewRowController.CommitAddNew();
                rowColumnIndex.RowIndex = addNewRowController.GetAddNewRowIndex();
                this.sfdatagrid.SelectedItems.Clear();
                //If the AddNewRowPosition is Top need to move the current cell to next row 
                if (this.sfdatagrid.AddNewRowPosition == AddNewRowPosition.Top)
                    rowColumnIndex.RowIndex = rowColumnIndex.RowIndex + 1;
                // Which retains the current cell border in the row after canceling addnewrow as you press esc key operation.
                this.sfdatagrid.MoveCurrentCell(rowColumnIndex);
            }
        }



        private void UIElement_OnTapped(object sender, TappedRoutedEventArgs e)
        {
            vm.AddOrder();
        }

        private void CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            sfdatagrid.GridColumnSizer.ResetAutoCalculationforAllColumns();
            sfdatagrid.GridColumnSizer.Refresh();
        }
    }
}